/*
** This software is Copyright (c) 1989, 1990, 1991, 1992, 1993
**                                1994, 1995 by Kent Landfield
**
** Permission is hereby granted to copy, distribute or otherwise 
** use any part of this package as long as you do not try to make 
** money from it or pretend that you wrote it.  This copyright 
** notice must be maintained in any copy made.
**
*/
#if !defined(lint) && !defined(CODECENTER)
static char SID[] = "@(#)mkargv.c	1.2 1/22/95";
#endif

#include <stdio.h>

/*
** Argument storage structure
*/

#define NODES_PER_HUNK  256

static int alloc_max = 0;      /* Allocated memory max files  */

/* M K A R G V
 *
 * mkargv() is used to add the supplied argument refered to
 * by str to the argv storage array.
 *
 * Called as:
 *     args = mkargv(&argc,&argv,"This is a string to save");
 *
 * Returns:
 *      argc - number of arguments
 *      -1   - malloc failed
 *      -2   - realloc failed
 */

int mkargv(argc, argv, str)
    int *argc;
    char **argv[];
    char *str;
{
    char *malloc();
    char *realloc();
    char *strcpy();

    char *p;

    if (alloc_max == 0) {
        *argv = (char **) malloc(sizeof(char *) * NODES_PER_HUNK);
        if (*argv == (char **) NULL) 
            return(-1);
        alloc_max = NODES_PER_HUNK;
    }
    else if (*argc == alloc_max) {
        *argv = (char **) realloc((char *) *argv, (unsigned) sizeof(char *)
                              * (alloc_max + NODES_PER_HUNK));
        if (*argv == (char **) NULL) 
            return(-2);
        alloc_max += NODES_PER_HUNK;
    }

    if (str != (char *) NULL) {
        if ((p = malloc((unsigned)(strlen(str) + 1))) == (char *) NULL) 
            return(-1);

        (void) strcpy(p, str);
        *(*argv + *argc) = p;
    }
    else 
        *(*argv + *argc) = (char *) NULL;

    *argc = *argc + 1;

    *(*argv + *argc) = (char *) NULL;

    return(*argc);

}

void freeargv(argc, argv)
    int argc;
    char **argv[];
{
    char *p;
    register int i;

    /*
    ** First free the contents.
    */

    for (i = 0; i< argc; i++) {
       p = *(*argv+i);
       if (*p != NULL) {
           free(p);
           *(*argv + i) = (char *) NULL;
       }
    }

    /*
    ** Free the pointer array.
    */
    free((char *) *argv);
    alloc_max = 0;
}
   
#ifdef NOTDEF
char **eargv;        /* Actual argument array       */
int eargc = 0;       /* Count of argv elements      */

int main()
{
  register int j;

  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");
  (void) mkargv(&eargc,&eargv,"This is a string to save");

  (void) printf("Print out stored data\n");
  for (j = 0; j < eargc; j++) 
       (void) printf("%s\n", eargv[j]);

  freeargv(eargc, &eargv);

  return 0;
}
#endif NOTDEF
